package lsedit;

import java.awt.*;
import java.awt.event.*;
import java.util.*;



public class NavigateModeHandler extends LandscapeModeHandler
{
	protected int curTab;
	protected boolean highFlag;		   
	protected boolean middleButton;
	protected boolean ctrlButton;

	protected final static String titleStr = "Navigate mode options";
	protected final static String helpStr = "Left - Enter (in viewer)\nCtrl+Left Exit\nMiddle - Enter (new viewer)";

	protected boolean navigateStart(MouseEvent ev) 
	{
		int x = ev.getX();
		int y = ev.getY();

		e = dg.mouseOver(x, y);

		if (e != null) {
			highFlag = true;
			if (e.isClickable()) {
				dg.drawEntityHighlight(gc, e);
				return true;
		}	}
		return false;
	}

	protected boolean navigateMotion(MouseEvent ev) 
	{
		int x = ev.getX();
		int y = ev.getY();

		if (highFlag) {
			if (dg.mouseOver(x, y) != e) {
				dg.undrawEntityHighlight(gc, e);
				highFlag = false;
			}
		} else {
			if (dg.mouseOver(x, y) == e) {
				dg.drawEntityHighlight(gc, e);
				highFlag = true;
			}
		}
		return true;

	}



	protected void navigateEnd(MouseEvent ev) 
	{
		int x = ev.getX();
		int y = ev.getY();

		EntityInstance over = dg.mouseOver(x, y);
		dg.undrawEntityHighlight(gc, e);
		if (over != e || over == null) {
			return;
		}
		ls.followLink(e, middleButton);
	}



	// --------------

	// Public methods

	// --------------



	public NavigateModeHandler() {

	}

	public void setHelp(TextBox tb) 
	{
		tb.set(titleStr, helpStr);
	}

	public boolean mouseDown(MouseEvent ev, int x, int y) {

//		System.out.println("NavigateModeHandler mousedown\n");

		middleButton = ev.isAltDown();

		return navigateStart(ev);

	}

	public boolean mouseDrag(MouseEvent ev) {

		if (e != null) {
			navigateMotion(ev);
		}
		return true;

	}



	public void mouseUp(MouseEvent ev, int x, int y) {

		if (e != null)

			navigateEnd(ev);

	}

	

	public void mouseDoubleClick(MouseEvent ev) 
	{
		int x = ev.getX();
		int y = ev.getY();

		EntityInstance over = dg.mouseOverEx(x, y);

		if (over != null) {
			boolean middleButton = ev.isAltDown();
			ls.followLink(over, middleButton);
		}
	}

}

