package lsedit;

import java.applet.*;
import java.awt.*;
import java.net.*;
import java.io.*;
import java.util.*;



public class ScrollableDiagram extends Diagram {

	protected static final int SB_WIDTH	 = 12;
	protected static final int SB_HEIGHT = 12;

	protected Scrollbar rightScroll, bottomScroll;

	protected int diffx, diffy;

	protected void posScroll() 
	{
		if (rightScroll != null) {
			rightScroll.setLocation(getX() + getWidth()-GAP-SB_WIDTH, getY()+GAP);
			rightScroll.setSize(SB_WIDTH, getHeight()-GAP*2-(SB_HEIGHT+1));
		}
		if (bottomScroll != null) {
			bottomScroll.setLocation(getX()+GAP, getY()+getHeight()-GAP-SB_HEIGHT); 
			bottomScroll.setSize(getWidth()-GAP*2-(SB_WIDTH+1), SB_HEIGHT);
	}	}

	protected void resetScroll() 
	{
/*
		Layout lyt = m_drawRoot.getLayout();

		int h = getHeight()-GAP*2;
		int w = getWidth()-GAP*2;

		// Set bottom scrollbar

		if (lyt.width <= (double) w) {
			if (bottomScroll.isVisible()) {
				MsgOut.dprintln("Hide: " + lyt.width + " " + w);
				bottomScroll.setVisible(false);
			}
		} else { 
			if (!bottomScroll.isVisible()) {
				bottomScroll.setVisible(true);
			}

			// Set scrollbar values
			diffx = (int) lyt.width - w;
			bottomScroll.setValues(-m_xoffset, w, 0, (int) lyt.width); // diffx);
		}

		// Set right scrollbar

		if (lyt.height <= (double) h) {
			if (rightScroll.isVisible()) {
				rightScroll.setVisible(false);
			}
		} else { 
			MsgOut.dprintln("Vert: " + lyt.height + " " + ((double) h));

			if (!rightScroll.isVisible()) {
				rightScroll.setVisible(true);
			}	

			// Set scrollbar values

			diffy = (int) lyt.height - h; 

			rightScroll.setValues(-m_yoffset, h, 0, (int) lyt.height); // diffy);

		}

*/

	}



	protected Graphics gContext(Graphics gc) {

		int vpwidth, vpheight;



		if (rightScroll.isVisible()) {
			vpwidth = getWidth()-(GAP*3+SB_WIDTH);
		} else {
			vpwidth = getWidth()-GAP*2;
		}


		if (bottomScroll.isVisible()) {
			vpheight = getHeight() - (GAP*3+SB_HEIGHT);
		} else {
			vpheight = getHeight() - GAP*2;
		}
		Graphics g = gc.create(getX()+GAP, getY()+GAP, vpwidth, vpheight);
		return g;
	}



	protected void scrollRightBar(Graphics gc, Event ev) {

		switch(ev.id)

		{

		case Event.SCROLL_LINE_UP:

		case Event.SCROLL_PAGE_UP:

			if (m_yoffset < 0) {

				m_yoffset = Math.min(m_yoffset+diffy/5, 0);

				rescaleDiagram();

				draw(gc);

			} 

			return;



		case Event.SCROLL_LINE_DOWN:

		case Event.SCROLL_PAGE_DOWN:

			if (m_yoffset > -diffy) {

				m_yoffset = Math.max(m_yoffset-diffy/5, -diffy);

				rescaleDiagram();

				draw(gc);

			}

			return;



		case Event.SCROLL_ABSOLUTE:

			m_yoffset = -(((Integer) ev.arg).intValue());

			rescaleDiagram();

			draw(gc);

			return;

		}

	}



	protected void scrollBottomBar(Graphics gc, Event ev) 
	{
		switch(ev.id)

		{

		case Event.SCROLL_LINE_UP:
		case Event.SCROLL_PAGE_UP:

			if (m_xoffset < 0) {
				m_xoffset = Math.min(m_xoffset+diffx/5, 0);
				rescaleDiagram();
				draw(gc);
			}
			return;


		case Event.SCROLL_LINE_DOWN:
		case Event.SCROLL_PAGE_DOWN:

			if (m_xoffset > -diffx) {
				m_xoffset = Math.max(m_xoffset-diffx/5, -diffx);
				rescaleDiagram();
				draw(gc);
			}
			return;



		case Event.SCROLL_ABSOLUTE:

			m_xoffset = -(((Integer) ev.arg).intValue());
			rescaleDiagram();
			draw(gc);
			return;
		}
	}







	// --------------

	// Public methods

	// --------------



	public ScrollableDiagram(LandscapeViewerCore ls)
	{
		super(ls, true);

		rightScroll  = new Scrollbar(Scrollbar.VERTICAL); 
		bottomScroll = new Scrollbar(Scrollbar.HORIZONTAL); 
		rightScroll.setVisible(false);
		bottomScroll.setVisible(false);
		add(rightScroll);
		add(bottomScroll);

		super.setBounds(0, 0, 10, 10);
	}



	public void setLocation(int x, int y) 
	{
		super.setLocation(x, y);
		posScroll();
	}



	public void setSize(int width, int height) 
	{
		super.setSize(width, height);
		posScroll();
	}



	public void setBounds(int x, int y, int width, int height)
	{
		super.setBounds(x, y, width, height);
		posScroll();
	}



	public Graphics getContext(Graphics gc) {

		int vpwidth, vpheight;



		if (rightScroll.isVisible()) {

			vpwidth = getWidth()-(GAP*3+SB_WIDTH);

		} else {

			vpwidth = getWidth()-GAP*2;
		}


		if (bottomScroll.isVisible())

			vpheight = getHeight() - (GAP*3+SB_HEIGHT);

		else

			vpheight = getHeight() - GAP*2;



		return gc.create(getX()+GAP, getY()+GAP, vpwidth, vpheight);

	}



	// Draw the entities, edges, and labels 



	public void draw(Graphics gc) {

		gc.setColor(Diagram.boxColour);

		gc.fillRect(getX(), getY(), getWidth(), getHeight());
		gc.draw3DRect(getX(), getY(), getWidth(), getHeight(), true);
		gc.draw3DRect(getX()+1, getY()+1, getWidth()-2, getHeight()-2, true);

		posScroll();



		Graphics g = getContext(gc);



		doDraw(g, m_drawRoot, (m_drawRoot != m_rootInstance)); 


		// drawCache.printStats();



		g.dispose();

	}



	public void draw(Graphics gc, EntityInstance e) {

		Graphics g = getContext(gc);



		super.draw(g, e);



		g.dispose();

	}



	// 

	// Generates global coordinates for current scale factor

	//

	public void rescaleDiagram() 
	{
		super.rescaleDiagram();
		resetScroll();
	}



	public int adjustX() 
	{
		return( - (getX()+GAP)); 
	}



	public int adjustY() 
	{
		return( - (getY()+GAP)); 
	}



	public void scroll(Graphics gc, Event ev) 
	{
		if (ev.target == rightScroll) {
			scrollRightBar(gc, ev);
		} else {
			scrollBottomBar(gc, ev);
	}	}

	public void navigateTo(EntityInstance e) 
	{
		super.navigateTo(e);
		resetScroll();
	}
}
